package org.netkernel.ext.system.accessor;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.meta.ISpaceElements;
import org.netkernel.layer0.meta.ISpaceMeta;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.layer0.representation.impl.HDSFactory;
import org.netkernel.layer0.util.XMLReadable;
import org.netkernel.layer0.util.XMLUtils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.request.IRequestResponseFields;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.IMetaRepresentation;
import org.netkernel.urii.ISpace;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class LocalMetaAggregator extends StandardAccessorImpl
{
	public LocalMetaAggregator()
	{	this.declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String tag=(String)this.getParameter("tag");
		IRepDeployedModules modules=aContext.source("active:moduleList",IRepDeployedModules.class);
		String ourSpaceHash=modules.hashForComponent(getSpace());
		ISpaceMeta spaceMeta=(ISpaceMeta)modules.metadataForHash(ourSpaceHash);
		ISpaceElements spaceElements=spaceMeta.getElements();
		
		HDSBuilder b=new HDSBuilder();
		b.pushNode("elements");
		
		for (int i=0; i<spaceElements.size(); i++)
		{
			String elementIdentifier=spaceElements.getIdentifier(i).toString();
			String elementHash=ourSpaceHash+"/"+elementIdentifier;
			IMetaRepresentation elementMeta=modules.metadataForHash(elementHash);
			IRequestResponseFields state=elementMeta.getAdditionalFields();
			Object value=state.getValue("meta");
			if (value instanceof Element)
			{
				XMLReadable r=new XMLReadable((Element)value);
				Node tagNode=r.getFirstNode(tag);
				if (tagNode!=null)
				{
					//System.out.println(elementIdentifier+" "+XMLUtils.toXML(tagNode, true, true));
					b.pushNode("element");
					b.addNode("id", elementIdentifier);
					b.pushNode("meta");
					b.importChildren(HDSFactory.parseDOM(tagNode));
					b.popNode();
					b.popNode();
				}
			}
		}
		aContext.createResponseFrom(b.getRoot());
	}
}
